<?php
/*
Plugin Name: Facebook Image Suggest
Plugin URI: http://www.59-media.de/facebook-image-suggest/
Description: Dieses Plugin definiert welches Bild bei Facebook f&uuml;r die Vorschau genutzt wird. Es extrahiert das erste Bild aus dem Artikel.
Version: 1.0
Author: Hauke Leweling | 59 MEDIA
Author URI: http://www.59-media.de/
Update Server: http://www.59-media.de/
Min WP Version: 2.7.0
Max WP Version: 3.0.5
*/

function facebook_image_suggest() 
{
	if (is_feed() || is_trackback() || !is_singular()) {
    	return null;
  	}
  	
	$PostImage = get_first_image();
	
	if(!is_null($PostImage))
  		echo '<link href="'.$PostImage.'" rel="image_src" />';
}

function get_first_image() 
{
	global $post, $posts;
	$FirstImage = null;
	ob_start();
	ob_end_clean();
	
	$output = preg_match_all('/<img.+src=[\'"]([^\'"]+)[\'"].*>/i', $post->post_content, $matches);
	
	$FirstImage = $matches [1] [0];
	
	if(!is_null($FirstImage))
	{
		return null;
	}

	return $FirstImage;
}

add_action('wp_head', 'facebook_image_suggest');